#include <Arduino.h>

void enter_bootloader()
{
  Serial.println("Bootloader mode");
  delay(1000);
  typedef void (*pFunction)(void);
  pFunction JumpToApplication;

  __HAL_RCC_USART1_FORCE_RESET();
  HAL_Delay(5);
  __HAL_RCC_USART1_RELEASE_RESET();
  HAL_Delay(5);

  HAL_RCC_DeInit();

  SysTick->CTRL = 0;
  SysTick->LOAD = 0;
  SysTick->VAL = 0;

  __disable_irq();
  __DSB();

  __HAL_SYSCFG_REMAPMEMORY_SYSTEMFLASH();

  __DSB();
  __ISB();

  JumpToApplication = (void (*)(void))(*((uint32_t *)((0x1FFFD800 + 4))));
  __set_MSP(*(__IO uint32_t *)0x1FFFD800);

  JumpToApplication();
}
